#---2018-9 jxp
import os
import re
import sys
import subprocess
import xml.etree.ElementTree as ET
from multiprocessing import Pool
# from multiprocessing import Pool as ThreadPool



def run_search(xml_file, protein_name):
	#print protein_name
	
	MSA = []
	
#	xml_file = '/home/xiaopeng/FATURE_RANK/result_xml/' + protein_name + '.txt' # result of psiblast in format 5
	#with open(fasta_file,'r') as f:
	#	print f.readlines()
	# parser the xml format
#	print xml_file
	tree = ET.ElementTree(file=xml_file)
	
	# get query info
	query_def = tree.find('BlastOutput_query-def').text
	# print query_def
	query_len = tree.find('BlastOutput_query-len').text
	# print query_len
	
	iteration = tree.findall('BlastOutput_iterations/Iteration')[-1]  # get the last iteration	
	
	Iteration_hits = iteration.find('Iteration_hits')

	for_num = 1	#for remove the first one in the xml file,which is the self	
	for Hit in Iteration_hits.getchildren():
		Hsp_evalue = Hit.find('Hit_hsps/Hsp/Hsp_evalue').text
		
		Hit_num = Hit.find('Hit_num').text
		Hit_id = Hit.find('Hit_id').text
		Hit_def = Hit.find('Hit_def').text
		
		Hsp_query_from = Hit.find('Hit_hsps/Hsp/Hsp_query-from').text
		Hsp_query_to = Hit.find('Hit_hsps/Hsp/Hsp_query-to').text
		Hsp_hit_from = Hit.find('Hit_hsps/Hsp/Hsp_hit-from').text
		Hsp_hit_to = Hit.find('Hit_hsps/Hsp/Hsp_hit-to').text
		Hsp_qseq = Hit.find('Hit_hsps/Hsp/Hsp_qseq').text
		Hsp_hseq = Hit.find('Hit_hsps/Hsp/Hsp_hseq').text
		Hsp_align_len = Hit.find('Hit_hsps/Hsp/Hsp_align-len').text	
		Hsp_identity = Hit.find('Hit_hsps/Hsp/Hsp_identity').text	
		Hsp_bit_score = Hit.find('Hit_hsps/Hsp/Hsp_bit-score').text	
		# alignment sequence by add prefix, suffix
		prefix = "-" * (int(Hsp_query_from) - 1)
		suffix = "-" * (int(query_len) - int(Hsp_query_to))
		
		# delete the space in protein_name and the corresponding position of hits
		pos = -1
		for aa in Hsp_qseq:
			pos = pos + 1
			if aa == '-':
				Hsp_hseq = Hsp_hseq[:pos] + '*' + Hsp_hseq[pos + 1:]
		Hsp_hseq = Hsp_hseq.replace('*', '')
		'''
		if 'X' in Hsp_hseq:
			Hsp_hseq = Hsp_hseq.replace('X', '-')
		if 'B' in Hsp_hseq:
			Hsp_hseq = Hsp_hseq.replace('B', '-')
		if 'Z' in Hsp_hseq:
			Hsp_hseq = Hsp_hseq.replace('Z', '-')
		if 'U' in Hsp_hseq:
			Hsp_hseq = Hsp_hseq.replace('U', '-')
		if 'J' in Hsp_hseq:
			Hsp_hseq = Hsp_hseq.replace('J', '-')
		if 'O' in Hsp_hseq:
			Hsp_hseq = Hsp_hseq.replace('O', '-')
		'''
#		print Hit_id
#		print protein_name
#		if 1:
		if  protein_name != Hit_id:
			hit_sequence = Hit_id + '\t' + Hsp_identity + '\t' + Hsp_evalue + '\t' + Hsp_bit_score + '\t' + Hsp_align_len 
			# append in MSA
			MSA.append(hit_sequence)
	return MSA
	
def write_MSA(MSA, filter_file):
#	fasta_file = '/home/xiaopeng/A-DATA/scop1.59/' + protein_name + '/' + protein_name + '.fasta2'
#	filter_file = '/home/xiaopeng/FATURE_RANK_3/db_filter/a.39.1.2test/' + protein_name + '.filter'
#	if MSA==[]:
#		# append the protein-self
#		#return
#		ff=open(fasta_file,'r')
#		ff.readline() # skip the id
#		fasta_seq=ff.readline().strip().upper()
#		ff.close()
#		MSA.append(fasta_seq)
	
	# write file
	#print len(MSA)
#	print "write file"
	output = open(filter_file, 'w')
	output.write('\n'.join(MSA))
	output.close()
	

if __name__ == '__main__':
	# parameters	
	
	xml_database = sys.argv[1]
	result_path = sys.argv[2]
	benchmark_database = os.listdir(xml_database)

	for benchmark in benchmark_database:
#	if_sign = 1
#	if if_sign == 1:
		protein_name = benchmark[:-4]
		#protein_name = 'd1ev4a1'
#		print '-----------FOR---------------'
		#print 'benchmark:\t' + benchmark
		#print 'protein_name:\t' + protein_name 
		filter_file = result_path + '/' + protein_name + '.txt'
		xml_file = xml_database + '/' + protein_name + '.txt' # result of psiblast in format 5
		#print filter_file
		#print xml_file
		with open(xml_file, 'r') as reader:
			all_lines = reader.readlines()
			if len(all_lines) == 0:
				MSA = []
				write_MSA(MSA, filter_file)
			else:
					
		#for line in range(len(feature_max_mtx)):
				MSA = run_search(xml_file, protein_name)
		#print "write_msa"
				write_MSA(MSA, filter_file)
			#if len(MSA) > 0:
			#	MSA_LIST.append(MSA)
		#break
		#filter_file = filter_path + protein_name + '.filter'
		#write_MSA(MSA, filter_file)
