__author__ = 'loolroco'
import sys
import time
import os
import numpy as np
import math
from math import isnan
import argparse
from argparse import RawTextHelpFormatter
import multiprocessing as mp
#for Standardized Euclidean
np.seterr(divide='ignore',invalid='ignore')
#end for


key2sf = {}
with open('[***need the path of source code]/scopekey2sf') as r_sf:
	for line in r_sf:
		line = line.strip().split()
		key2sf[line[0]] = line[1]
# print key2sf


def read_feature(filename):
	res={}
	with open(filename) as fp:
		for line in fp.readlines():
			tt=line.split()
			res[tt[0]]=tt[1:]
	return res
 

result_ACCPSSM=read_feature("[***need the path of feature db for scope]/query_accpssm.txt")
result_TOP1=read_feature("[***need the path of feature db for scope]/query_TOP1.txt")
result_TOP2=read_feature("[***need the path of feature db for scope]/query_TOP2.txt")
result_PDTPSSM=read_feature("[***need the path of feature db for scope]/query_pdtpssm.txt")
result_DT=read_feature("[***need the path of feature db for scope]/query_dt.txt")

result_KMER2=read_feature("[***need the path of feature db for scope]/query_kmer2.txt")
result_DR=read_feature("[***need the path of feature db for scope]/query_dr.txt")
result_DP=read_feature("[***need the path of feature db for scope]/query_distancepair.txt")

result_AC=read_feature("[***need the path of feature db for scope]/query_ac.txt")
result_CC=read_feature("[***need the path of feature db for scope]/query_cc.txt")
result_ACC=read_feature("[***need the path of feature db for scope]/query_acc.txt")
result_PDT=read_feature("[***need the path of feature db for scope]/query_pdt.txt")

result_PC_PSEAAC=read_feature("[***need the path of feature db for scope]/query_pcpseaac.txt")
result_SC_PSEAAC=read_feature("[***need the path of feature db for scope]/query_scpseaac.txt")


parse = argparse.ArgumentParser(description="This is query vectors.",
                                    formatter_class=RawTextHelpFormatter)
parse.add_argument('-query_accpssm', type=str,
                       help="The input files for storing feature vectors query_accpssm.")
parse.add_argument('-query_TOP1', type=str,
                       help="The input files for storing feature vectors query_TOP1.")
parse.add_argument('-query_TOP2', type=str,
                       help="The input files for storing feature vectors query_TOP2.")
parse.add_argument('-query_pdtpssm', type=str,
                       help="The input files for storing feature vectors query_pdtpssm.")
parse.add_argument('-query_dt', type=str,
                       help="The input files for storing feature vectors query_dt.")
                       
parse.add_argument('-query_kmer2', type=str,
                       help="The input files for storing feature vectors query_kmer2.")
parse.add_argument('-query_dr', type=str,
                       help="The input files for storing feature vectors query_dr.")
parse.add_argument('-query_distancepair', type=str,
                       help="The input files for storing feature vectors query_distancepair.")
                       
parse.add_argument('-query_ac', type=str,
                       help="The input files for storing feature vectors query_ac.")
parse.add_argument('-query_cc', type=str,
                       help="The input files for storing feature vectors query_cc.")
parse.add_argument('-query_acc', type=str,
                       help="The input files for storing feature vectors query_acc.")
parse.add_argument('-query_pdt', type=str,
                       help="The input files for storing feature vectors query_pdt.")
                       
parse.add_argument('-query_pcpseaac', type=str,
                       help="The input files for storing feature vectors query_pcpseaac.")
parse.add_argument('-query_scpseaac', type=str,
                       help="The input files for storing feature vectors query_scpseaac.")
                       
parse.add_argument('-psi', type=str,
                       help="The input files for psi.")
parse.add_argument('-aggre', type=str,
                       help="The output files for aggre.")
args = parse.parse_args()


query_ACCPSSM=read_feature(args.query_accpssm)
query_TOP1=read_feature(args.query_TOP1)
query_TOP2=read_feature(args.query_TOP2)
query_pdtpssm=read_feature(args.query_pdtpssm)
query_dt=read_feature(args.query_dt)

query_kmer2=read_feature(args.query_kmer2)
query_dr=read_feature(args.query_dr)
query_distancepair=read_feature(args.query_distancepair)

query_ac=read_feature(args.query_ac)
query_cc=read_feature(args.query_cc)
query_acc=read_feature(args.query_acc)
query_pdt=read_feature(args.query_pdt)

query_pcpseaac=read_feature(args.query_pcpseaac)
query_scpseaac=read_feature(args.query_scpseaac)


def getVecOfSeq(name1,result):
	return result[name1];


def load_data(filename):
	res = {}
	with open(filename) as reader:
		for line in reader:
			line = line.strip().split()
			if line[0] not in res:
				res[line[0]] = [i for i in line[1:]]
				# print res[line[0]]
	return res


def is_same_sf(key1, key2):
	k1_sf = key2sf[key1]
	k2_sf = key2sf[key2]

	if k1_sf == k2_sf:
		return 1
	else:
		return 0

def map_feature_sim_LTR30(vec1,vec2):
	res=[]
	for i in range(len(vec1)):
		res.append(str(-math.fabs(float(vec1[i])-float(vec2[i]))))
	return res

#jxp change
def map_feature_sim(vec1,vec2):
	#print '-----------------------'
	#vec11 = "".join(vec1)
	vec11 = np.array(map(eval,vec1))
	#vec22 = "".join(vec2)
	vec22 = np.array(map(eval,vec2))
	#print vec11
	#print vec22
	res=[]
	
	x = vec11
	y = vec22
	
	#Euclidean Distance
	d1 = np.sqrt(np.sum(np.square(x-y)))
	#Manhattan distance
	d2 = np.sum(np.abs(x-y))
	#Pearsons Correlation score
	x_=x-np.mean(x)
	y_=y-np.mean(y)
	d3 = np.dot(x_,y_)/(np.linalg.norm(x_)*np.linalg.norm(y_))
	#Chebyshev 
	d4=np.max(np.abs(x-y))
	#Minkowski !!!!same with Euclidean Distance, auto dealing by leaning to rank
	d5=np.sqrt(np.sum(np.square(x-y)))
	#Standardized Euclidean
	#	the value of sk may be zero
#	X=np.vstack([x,y])
#	sk=np.var(X,axis=0,ddof=1)
	#print 'sk'
	#print sk
#	d6=np.sqrt(((x - y) ** 2 /sk).sum())
	#Mahalanobis 
	# 	num problem
	#Cosine
	d7=np.dot(x,y)/(np.linalg.norm(x)*np.linalg.norm(y))
	#Bray Curtis 
	up=np.sum(np.abs(y-x))
	down=np.sum(x)+np.sum(y)
	if down != 0:
		d8=(up/down)
	else:
		d8 = 0
	#KL-Divergence

	p = vec11
	q = vec22
	#d4 = np.sum(p*np.log(p/q))
	# if the result of d4 = nan, change the value of d4 to zero  
#	if isnan(d4):
#		d4 = 0
	res.append(str(d1))
	res.append(str(d2))
	res.append(str(d3))
	res.append(str(d4))
	res.append(str(d5))
#	res.append(str(d6))
	res.append(str(d7))
	res.append(str(d8))
	return res


def formate_run(fn, method_path, result_path):
		res = {}
		# load hits_pr_hhr
		psi_dic = {}
		if os.path.isfile(method_path[0] + '/' + fn):
			psi_dic= load_data(method_path[0] + '/' + fn)

		# combine dic
		keys_set = []
		for x in [psi_dic.keys()]:
			keys_set += x
		keys_set = set(keys_set)

		# write file
		with open(os.path.join(result_path, fn), 'w') as writer:
			for key in keys_set:

				vec_len = ['0'] * 5 # psiblast:4 hmmer:3 hhblits:4 
				key1 = os.path.splitext(fn)[0]
				key2=key
				homo_flag = 0
				# add features
				if key in psi_dic:
					vec_len[0:5] = psi_dic[key]

				tmp=np.hstack([map_feature_sim(getVecOfSeq(key1,query_ACCPSSM),getVecOfSeq(key,result_ACCPSSM)),map_feature_sim(getVecOfSeq(key1,query_TOP1),getVecOfSeq(key,result_TOP1)) ])
				tmp=np.hstack([tmp,map_feature_sim(getVecOfSeq(key1,query_TOP2),getVecOfSeq(key,result_TOP2))])
				tmp=np.hstack([tmp,map_feature_sim(getVecOfSeq(key1,query_pdtpssm),getVecOfSeq(key,result_PDTPSSM))])
				tmp=np.hstack([tmp,map_feature_sim(getVecOfSeq(key1,query_dt),getVecOfSeq(key,result_DT))])
				
				tmp=np.hstack([tmp,map_feature_sim(getVecOfSeq(key1,query_kmer2),getVecOfSeq(key,result_KMER2))])
				tmp=np.hstack([tmp,map_feature_sim(getVecOfSeq(key1,query_dr),getVecOfSeq(key,result_DR))])
				tmp=np.hstack([tmp,map_feature_sim(getVecOfSeq(key1,query_distancepair),getVecOfSeq(key,result_DP))])
				
				tmp=np.hstack([tmp,map_feature_sim(getVecOfSeq(key1,query_ac),getVecOfSeq(key,result_AC))])
				tmp=np.hstack([tmp,map_feature_sim(getVecOfSeq(key1,query_cc),getVecOfSeq(key,result_CC))])
				tmp=np.hstack([tmp,map_feature_sim(getVecOfSeq(key1,query_acc),getVecOfSeq(key,result_ACC))])
				tmp=np.hstack([tmp,map_feature_sim(getVecOfSeq(key1,query_pdt),getVecOfSeq(key,result_PDT))])

				tmp=np.hstack([tmp,map_feature_sim(getVecOfSeq(key1,query_pcpseaac),getVecOfSeq(key, result_PC_PSEAAC))])
				tmp=np.hstack([tmp,map_feature_sim(getVecOfSeq(key1,query_scpseaac),getVecOfSeq(key, result_SC_PSEAAC))])
				vec_len[5:]=tmp

				features_str = ''
				for i, feature in enumerate(vec_len):
					features_str += str(i + 1) + ':' + feature + ' '
				writer.write(str(homo_flag) + ' ' + 'qid:' +
							 key1 + ' ' + features_str + ' # ' + key1 +' ' + ' | ' + key2 +' '+ '\n')



def formate_input(method_path, result_path):
	# load file name into a set
	filename = []
	for path in method_path:
		filename.extend(os.listdir(path))
	filename = set(filename)
	# for each sequence, aggregate four basic methods' results
	pool = mp.Pool(10)
	for fn in filename:
		pool.apply_async(formate_run, (fn, method_path, result_path) )
	pool.close()
	pool.join()
if __name__ == '__main__':
	formate_input([args.psi], args.aggre)
