#---2018-7 jxp
#filter msa by feature
import os
import re
import sys
import subprocess
import xml.etree.ElementTree as ET
from multiprocessing import Pool
import multiprocessing as mp
import numpy as np
import os.path

def np_norm(protein_name, path1, path2, fasta_path, iternum):
	ori = path1+'/resultiter'+str(iternum)+'/psiblast/TMP/'+protein_name+'.msa'
	ltr = path2+protein_name+'.txt'
	cur = path1+'/resultiter'+str(iternum)+'/psiblast/TMP/' +protein_name+'.msa2'
	fasta_list = fasta_path
	hitdb_file = path1+'/resultiter'+str(iternum)+'/psiblast/TMP/' + protein_name + '.hit_db'
	outputhitdb = open(hitdb_file, 'w')


#   last iteration MSA and hit_db
	if iternum > 2:
		last_msa = path1+'/TMP'+str(int(iternum)-1)+'/'+protein_name+'.msa2'
		last_hitdb = path1+'/TMP'+str(int(iternum)-1)+'/'+protein_name+'.hit_db'
		if not os.path.isfile(last_msa):
			lmsa = np.array([], dtype=int)
		else:
			with open(last_msa, 'r') as reader:
				all_lines = reader.readlines()
				if len(all_lines) == 0:
					lmsa = np.array([], dtype=int)
				else:
					lmsa = np.genfromtxt(last_msa, dtype='string', comments=' ')
					lhitdb = np.genfromtxt(last_hitdb, dtype='string', comments=' ')
	else:
		lmsa = np.array([], dtype=int64)
	return_sign = 0
	with open(ori, 'r') as reader:
		all_lines = reader.readlines()
		if len(all_lines) == 0:
			return_sign = -1
	ori_data = np.genfromtxt(ori, dtype='string', comments='#')
	if len(ori_data.shape) == 1:
		ori_data = np.asarray([ori_data])
	if not os.path.isfile(ltr):
		return -2
	with open(ltr, 'r') as reader:
		all_lines = reader.readlines()
		if len(all_lines) == 0:
			outputhitdb.close()
			return_sign = -1
	if return_sign == -1 and iternum > 2:
		return -1
	elif return_sign == -1:
		return -1

	# load data
	ltr_data = np.genfromtxt(ltr, dtype='string', comments='$')
	if len(ltr_data.shape) == 1:
		ltr_data = np.asarray([ltr_data])
	ltr_data2 = ltr_data[:,0:1]
	ltr_num = 0
	ori_num = 0
	ori_data2 = []
	
	if lmsa.size < 1 or iternum < 3:
		ori_data2.append(ori_data[0])
		with open (path1+'/query/' +protein_name+'.seq', 'r') as fl:
			fl_line = fl.read()
			outputhitdb.write(fl_line)

		for ltr_line in ltr_data2:
			for ori_line in ori_data:
				if ori_line[0] == ltr_line[0]:
					ori_data2.append(ori_data[ori_num])
					with open (fasta_list+ltr_line[0]+'/'+ltr_line[0]+'.fasta', 'r') as fl:
						fl_line = fl.read()
						outputhitdb.write(fl_line)
				ori_num = ori_num + 1
			ori_num = 0
	else:
		lmsa2 = np.genfromtxt(last_msa, dtype='string',comments='#')
		last_hitdb_num = 0
		for lmsa2_line in lmsa2:
			ori_where_num =  np.where(ori_data==lmsa2_line[0])[0]#.size > 0:
			if ori_where_num.size > 0:
				ori_data2.append(ori_data[ori_where_num[0]])
				outputhitdb.write(lhitdb[last_hitdb_num*2]+'\n')
				outputhitdb.write(lhitdb[last_hitdb_num*2+1]+'\n')
			last_hitdb_num = last_hitdb_num + 1
		for ltr_line in ltr_data2:
			if np.where(lmsa==ltr_line)[0].size == 0:
				ori_data2.append(ori_data[np.where(ori_data==ltr_line)[0][0]])
				with open (fasta_list+ltr_line[0]+'/'+ltr_line[0]+'.fasta', 'r') as fl:
					fl_line = fl.read()
					outputhitdb.write(fl_line)
	outputhitdb.close()
	np.savetxt(cur, ori_data2, fmt='%s')
	return 0

def run_search(protein_name, fasta_path, xml_database, path1, path2, iternum):
	#print protein_name
	
	MSA = []
	HIT_DB = []	
	fasta_file = path1+'/query/' + protein_name + '.seq'
	fasta_list = fasta_path
	xml_file = xml_database + protein_name + '.txt'
	filter_file = path1+'/resultiter'+str(iternum)+'/psiblast/TMP/' + protein_name + '.msa'
	protein_path = path1+'/resultiter'+str(iternum)+'/psiblast/TMP/'+protein_name
	iter2_path = path1+'/resultiter'+str(iternum)+'/psiblast/ori/'+protein_name
	xml_protein_name_line = []
	tree = ET.ElementTree(file=xml_file)

	# get query info
	query_def = tree.find('BlastOutput_query-def').text
	# print query_def
	query_len = tree.find('BlastOutput_query-len').text
	# print query_len
	
	iteration = tree.findall('BlastOutput_iterations/Iteration')[-1]  # get the last iteration	
	
	Iteration_hits = iteration.find('Iteration_hits')
	
	for Hit in Iteration_hits.getchildren():
		Hsp_evalue = Hit.find('Hit_hsps/Hsp/Hsp_evalue').text
		
		Hit_num = Hit.find('Hit_num').text
		Hit_id = Hit.find('Hit_id').text
		Hit_def = Hit.find('Hit_def').text
		
		Hsp_query_from = Hit.find('Hit_hsps/Hsp/Hsp_query-from').text
		Hsp_query_to = Hit.find('Hit_hsps/Hsp/Hsp_query-to').text
		Hsp_hit_from = Hit.find('Hit_hsps/Hsp/Hsp_hit-from').text
		Hsp_hit_to = Hit.find('Hit_hsps/Hsp/Hsp_hit-to').text
		Hsp_qseq = Hit.find('Hit_hsps/Hsp/Hsp_qseq').text
		Hsp_hseq = Hit.find('Hit_hsps/Hsp/Hsp_hseq').text
		
		
		# alignment sequence by add prefix, suffix
		prefix = "-" * (int(Hsp_query_from) - 1)
		suffix = "-" * (int(query_len) - int(Hsp_query_to))
		
		# delete the space in protein_name and the corresponding position of hits
		pos = -1
		for aa in Hsp_qseq:
			pos = pos + 1
			if aa == '-':
				Hsp_hseq = Hsp_hseq[:pos] + '*' + Hsp_hseq[pos + 1:]
		Hsp_hseq = Hsp_hseq.replace('*', '')
		
#		print '------------' + Hit_id + '---------------'
	
		# combine prefix, modified hits, suffix
		hit_sequence = Hit_id + '\t' + prefix + Hsp_hseq + suffix
		
		# append in MSA
		if protein_name !=  Hit_id:
			MSA.append(hit_sequence)
		else:
			xml_protein_name_line.append(hit_sequence)
	if MSA==[]:
		# append the protein-self
		print 'msa = null'
	else:	
		output = open(filter_file, 'w')
		if len(xml_protein_name_line) == 0:
			query_head_data = np.genfromtxt(path1+'/query/' +protein_name+'.seq', dtype='string', comments='>')
			print type(query_head_data.tostring())
			xml_protein_name_line.append(protein_name+'\t'+query_head_data.tostring())
		output.write(''.join(xml_protein_name_line))
		output.write('\n')
		output.write('\n'.join(MSA))
		output.close()
		print MSA
				
		np_num =  np_norm(protein_name, path1, path2, fasta_path, iternum)
		if np_num == -1:
			cmd_cp = 'cp '+xml_database+protein_name+'.txt '+path1+'/ITER'+str(iternum)+'/'
			subprocess.call(cmd_cp, shell=True)
			return
		elif np_num == -2:
			return
	
		cmd_mkdb = '/home/www/SMI-BLAST/webserver/model/ncbi-blast-2.7.1+/bin/makeblastdb -in ' + protein_path + '.hit_db -dbtype prot -parse_seqids'
		cmd_mkpssm = '/home/www/SMI-BLAST/webserver/model/ncbi-blast-2.7.1+/bin/psiblast -max_target_seqs 5000 -outfmt 7 -inclusion_ethresh 100.0 -in_msa ' + protein_path + '.msa2 -db ' + protein_path + '.hit_db -out_pssm ' + protein_path + '.asntxt  -num_iterations 1 -save_pssm_after_last_round'
		cmd_psiblast = '/home/www/SMI-BLAST/webserver/model/ncbi-blast-2.7.1+/bin/psiblast -num_threads 4  -outfmt 5 -inclusion_ethresh 0.002000 -evalue 10.000000 -num_iterations '+str(int(iternum)-1)+' -db /home/www/SMI-BLAST/webserver/model/db/psiblast/scope-95-2.06/scope-95-2.06 -in_pssm ' + protein_path + '.asntxt -out ' + iter2_path + '.txt'
		print cmd_psiblast
		subprocess.call(cmd_mkdb, shell=True)
		subprocess.call(cmd_mkpssm, shell=True)
		subprocess.call(cmd_psiblast, shell=True)

if __name__ == '__main__':
	# parameters
	path1 = sys.argv[1]
	path2 = sys.argv[2]
	fasta_path = sys.argv[3]
	xml_database = sys.argv[4]
	iternum = sys.argv[5]
	benchmark_database = os.listdir(path2)
	pool = mp.Pool(10)
	for benchmark in benchmark_database:
		run_search(benchmark[:-4], fasta_path, xml_database, path1, path2, iternum)
	pool.close()
	pool.join()
	
