#!/usr/bin/env bash
usr_dir=$1  #userfile directory
cutoff=$2   #iteration number
CON_FOLD=$3  # source code path
cd ${CON_FOLD}
bash init.sh ${usr_dir}
# basic method command
# psiblast
result_path=resultiter1
bash psiblast.sh ${usr_dir} 'scope-95-2.06' ${CON_FOLD} ${result_path}

#Feature combine
python formate_vec_merge.py -psi ${usr_dir}/${result_path}/psiblast/nor -query_TOP1 ${usr_dir}/feature/query_TOP1.txt -query_TOP2 ${usr_dir}/feature/query_TOP2.txt -query_accpssm ${usr_dir}/feature/query_accpssm.txt -query_pdtpssm ${usr_dir}/feature/query_pdtpssm.txt -query_dt ${usr_dir}/feature/query_dt.txt -query_kmer2 ${usr_dir}/feature/query_kmer2.txt -query_dr ${usr_dir}/feature/query_dr.txt -query_distancepair ${usr_dir}/feature/query_distancepair.txt -query_ac ${usr_dir}/feature/query_ac.txt -query_cc ${usr_dir}/feature/query_cc.txt -query_acc ${usr_dir}/feature/query_acc.txt -query_pdt ${usr_dir}/feature/query_pdt.txt -query_pcpseaac ${usr_dir}/feature/query_pcpseaac.txt -query_scpseaac ${usr_dir}/feature/query_scpseaac.txt -aggre ${usr_dir}/resultiter1/aggregation

#Feature file
cat ${usr_dir}/resultiter1/aggregation/* > ${usr_dir}/LTR_input_iter1

#predict
/opt/Java/bin/java -jar [***need Ranklib PATH]/bin/RankLib-2.7.jar -load [***need leaning to rank model for first iteration] -rank ${usr_dir}/LTR_input_iter1 -score ${usr_dir}/score/LTR_score_iter1 -norm linear

ltr_input=LTR_input_iter1
ltr_score=LTR_score_iter1
bash coma.sh ${usr_dir} ${result_path} ${ltr_input} ${ltr_score}

if [ ${cutoff} = "2" ]; then
  cd $usr_dir
  mkdir resultiter2
  cd ./resultiter2
  mkdir aggregation psiblast rerankdir sort sort_cut
  cd psiblast
  mkdir nor ori new TMP
  cd $CON_FOLD

  iteration=2
  python ltr-iter.py ${usr_dir} ${usr_dir}/resultiter1/sort_cut/ /home/www/SMI-BLAST/webserver/model/db/scope-95-2.06/  ${usr_dir}/resultiter1/psiblast/ori/ ${iteration}
  result_path=resultiter${iteration}
  bash psiblast2.sh ${usr_dir} 'scope-95-2.06' ${CON_FOLD} ${result_path}
  #format
  python formate_vec_merge.py -psi ${usr_dir}/${result_path}/psiblast/nor -query_TOP1 ${usr_dir}/feature/query_TOP1.txt -query_TOP2 ${usr_dir}/feature/query_TOP2.txt -query_accpssm ${usr_dir}/feature/query_accpssm.txt -query_pdtpssm ${usr_dir}/feature/query_pdtpssm.txt -query_dt ${usr_dir}/feature/query_dt.txt -query_kmer2 ${usr_dir}/feature/query_kmer2.txt -query_dr ${usr_dir}/feature/query_dr.txt -query_distancepair ${usr_dir}/feature/query_distancepair.txt -query_ac ${usr_dir}/feature/query_ac.txt -query_cc ${usr_dir}/feature/query_cc.txt -query_acc ${usr_dir}/feature/query_acc.txt -query_pdt ${usr_dir}/feature/query_pdt.txt -query_pcpseaac ${usr_dir}/feature/query_pcpseaac.txt -query_scpseaac ${usr_dir}/feature/query_scpseaac.txt -aggre ${usr_dir}/${result_path}/aggregation
  #merge
  cat ${usr_dir}/${result_path}/aggregation/* > ${usr_dir}/LTR_input_iter${iteration}
  #predict
  /opt/Java/bin/java -jar [***need Ranklib PATH]/RankLib-2.7.jar -load [***need leaning to rank model for second iteration] -rank ${usr_dir}/LTR_input_iter2 -score ${usr_dir}/score/LTR_score_iter${iteration} -norm linear
  ltr_input=LTR_input_iter${iteration}
  ltr_score=LTR_score_iter${iteration}
  bash coma.sh ${usr_dir} ${result_path} ${ltr_input} ${ltr_score}
  
elif [ ${cutoff} = "3" ]; then
  cd $usr_dir
  mkdir resultiter5
  cd ./resultiter5
  mkdir aggregation psiblast rerankdir sort sort_cut
  cd psiblast
  mkdir nor ori new TMP
  cd $CON_FOLD
  
  iteration=5
  python ltr-iter.py ${usr_dir} ${usr_dir}/resultiter1/sort_cut/ /home/www/SMI-BLAST/webserver/model/db/scope-95-2.06/  ${usr_dir}/resultiter1/psiblast/ori/ ${iteration}
  result_path=resultiter${iteration}
  bash psiblast2.sh ${usr_dir} 'scope-95-2.06' ${CON_FOLD} ${result_path}
  #format
  python formate_vec_merge.py -psi ${usr_dir}/${result_path}/psiblast/nor -query_TOP1 ${usr_dir}/feature/query_TOP1.txt -query_TOP2 ${usr_dir}/feature/query_TOP2.txt -query_accpssm ${usr_dir}/feature/query_accpssm.txt -query_pdtpssm ${usr_dir}/feature/query_pdtpssm.txt -query_dt ${usr_dir}/feature/query_dt.txt -query_kmer2 ${usr_dir}/feature/query_kmer2.txt -query_dr ${usr_dir}/feature/query_dr.txt -query_distancepair ${usr_dir}/feature/query_distancepair.txt -query_ac ${usr_dir}/feature/query_ac.txt -query_cc ${usr_dir}/feature/query_cc.txt -query_acc ${usr_dir}/feature/query_acc.txt -query_pdt ${usr_dir}/feature/query_pdt.txt -query_pcpseaac ${usr_dir}/feature/query_pcpseaac.txt -query_scpseaac ${usr_dir}/feature/query_scpseaac.txt -aggre ${usr_dir}/${result_path}/aggregation
  #merge
  cat ${usr_dir}/${result_path}/aggregation/* > ${usr_dir}/LTR_input_iter${iteration}
  #predict
  /opt/Java/bin/java -jar [***need Ranklib PATH]/RankLib-2.7.jar -load [***need leaning to rank model for fifth iteration] -rank ${usr_dir}/LTR_input_iter${iteration} -score ${usr_dir}/score/LTR_score_iter${iteration} -norm linear
  ltr_input=LTR_input_iter${iteration}
  ltr_score=LTR_score_iter${iteration}
  bash coma.sh ${usr_dir} ${result_path} ${ltr_input} ${ltr_score}

elif [ ${cutoff} = "4" ]; then
  cd $usr_dir
  mkdir resultiter10
  cd ./resultiter10
  mkdir aggregation psiblast rerankdir sort sort_cut
  cd psiblast
  mkdir nor ori new TMP
  cd $CON_FOLD

  iteration=10
  python ltr-iter.py ${usr_dir} ${usr_dir}/resultiter1/sort_cut/ /home/www/SMI-BLAST/webserver/model/db/scope-95-2.06/  ${usr_dir}/resultiter1/psiblast/ori/ ${iteration}
  result_path=resultiter${iteration}
  bash psiblast2.sh ${usr_dir} 'scope-95-2.06' ${CON_FOLD} ${result_path}
  #format
  python formate_vec_merge.py -psi ${usr_dir}/${result_path}/psiblast/nor -query_TOP1 ${usr_dir}/feature/query_TOP1.txt -query_TOP2 ${usr_dir}/feature/query_TOP2.txt -query_accpssm ${usr_dir}/feature/query_accpssm.txt -query_pdtpssm ${usr_dir}/feature/query_pdtpssm.txt -query_dt ${usr_dir}/feature/query_dt.txt -query_kmer2 ${usr_dir}/feature/query_kmer2.txt -query_dr ${usr_dir}/feature/query_dr.txt -query_distancepair ${usr_dir}/feature/query_distancepair.txt -query_ac ${usr_dir}/feature/query_ac.txt -query_cc ${usr_dir}/feature/query_cc.txt -query_acc ${usr_dir}/feature/query_acc.txt -query_pdt ${usr_dir}/feature/query_pdt.txt -query_pcpseaac ${usr_dir}/feature/query_pcpseaac.txt -query_scpseaac ${usr_dir}/feature/query_scpseaac.txt -aggre ${usr_dir}/${result_path}/aggregation
  #merge
  cat ${usr_dir}/${result_path}/aggregation/* > ${usr_dir}/LTR_input_iter${iteration}
  #predict
  /opt/Java/bin/java -jar [***need Ranklib PATH]/RankLib-2.7.jar -load [***need leaning to rank model for tenth iteration] -rank ${usr_dir}/LTR_input_iter${iteration} -score ${usr_dir}/score/LTR_score_iter${iteration} -norm linear
  ltr_input=LTR_input_iter${iteration}
  ltr_score=LTR_score_iter${iteration}
  bash coma.sh ${usr_dir} ${result_path} ${ltr_input} ${ltr_score}
fi

